'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals


class Shower(InteractionObject):
    def __init__(self,ia):
        super(Shower,self).__init__(ia)
        
    def used(self,item):
        InteractionObject.used(self,item)
        gm = globals.game
        pl = globals.player        
        gm.displayText("Now's not the time for a shower...", 4.0)
            
            
class Cabinet(InteractionObject):
    def __init__(self,ia):
        super(Cabinet,self).__init__(ia)
        self.contents = ["red pill","blue pill"]
        
    def used(self,item):
        InteractionObject.used(self,item)
        gm = globals.game
        pl = globals.player
        
        if len(self.contents)==0:
            gm.displayText("I've got everything from here", 4.0)
        else:
            options = ["grab "+i for i in self.contents]
            gm.query(self,options)       
            
    def notify(self, str):
        if str==None: return
        
        gm = globals.game
        pl = globals.player
        if str[:4]=="grab":
            self.closedpills.show = False
            self.openpills.show = True
            
            takewhat = str[5:]
            self.contents.remove(takewhat)
            pl.addItem(takewhat)
                    
class Bathroom(Room):
   
    def __init__(self):
        super(Bathroom,self).__init__("A bathroom","bathroom.dat")
        self.loadAndSortObjects({'pills_open':StaticThing("pills_open.png"),'pills_closed':StaticThing("pills_closed.png")})
                                 
        self.setInteractionZones({'cabinet':Cabinet,'shower':Shower})
        
        cabinet = self.getInteractionObject('cabinet')
        cabinet.closedpills = self.getObject('pills_closed')
        cabinet.openpills = self.getObject('pills_open')
        cabinet.closedpills.show = True
        cabinet.openpills.show = False
        
      