'''
Created on 01/05/2009

@author: ben
'''

'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals
import pyglet
from pyglet import gl

class Cat(Thing):        
    def __init__(self):
        super(Cat,self).__init__()
        
        self.imgGrowling = pyglet.resource.image("cat_growling.png")
        self.imgYelling = pyglet.resource.image("cat_yelling.png")
        self.imgHappy = pyglet.resource.image("cat_happy.png")
        self.imgs = [self.imgGrowling,self.imgHappy,self.imgYelling]
        
        self.state = "growling"
        self.color = (1,1,1)
        
        self.localUpdateNeeded = True
        
    def postinit(self):
        if self.pivot:
            for img in self.imgs:
                img.anchor_x,img.anchor_y = self.pivot.x,self.pivot.y
            
    def draw(self):        
        img = {"growling":self.imgGrowling,"yelling":self.imgYelling,"happy":self.imgHappy}[self.state]
        apply(gl.glColor3f,self.color)
        img.blit(self.position.x,self.position.y)
    
    def angry(self):
        self.state="yelling"
        globals.game.notify("cat yelling")
        
    def localUpdate(self,dt):
        if self.state=="growling":
            if globals.player.room == self.room:
                d = Thing.distance(globals.player,self)
                if (d < 100):
                    self.angry()
                elif (d < 200):
                    dd = max(100,d) - 100
                    df = 1.0*dd/100                
                    self.color = (1,df,df)                    
                    
    def fruit(self):
        self.state = "happy"
        self.color = (1,1,1)
            
class CatArea(InteractionObject):
    def __init__(self,ia):
        super(CatArea,self).__init__(ia)
        self.active = True
        self.kitteh = None
        self.msgcount = 0
        
        self.msgs = ["That cat looks angry","I shouldn't go too close to it","Maybe some food will distract it?"]
    
    def entered(self):
        InteractionObject.entered(self)
        
        if self.active:
            globals.game.displayText(self.msgs[self.msgcount],4.0)            
            self.msgcount = min(self.msgcount+1,2)
    
    def used(self,item):
        InteractionObject.used(self,item)
        
        if self.active:
            gm = globals.game
            pl = globals.player 
            
            if len(pl.inventory)>0:
                gm.query(self,["give " + o for o in pl.inventory])
            else:
                gm.displayText("It looks hungry...",3)

    def notify(self,str):
        gm = globals.game
        pl = globals.player
        
        if str==None: return
        
        if str=="give a stripey fruit":
            gm.displayText("nice kitteh", 1.0)
            gm.scheduleOnce(lambda dt: gm.displayText("kitteh likes stripes!",3.0), 1.0)
            self.kitteh.fruit()
            self.active = False
        else:
            gm.displayText("I shouldn't have done that...", 4.0)
            self.kitteh.angry()
            self.active = False           
                
class CatRoom(Room):
    
    def __init__(self):
        super(CatRoom,self).__init__("A room with a cat","catroom.dat")
        self.setInteractionZones({'catarea':CatArea})
        self.loadAndSortObjects({'cat':Cat()})
        
        self.getInteractionObject('catarea').kitteh = self.getObject('cat')
        
#===============================================================================
#        
#        bench = self.getInteractionObject('bench')
#        bench.screwdriver = self.getObject('screwdriver')
#        bench.boltcutters = self.getObject('boltcutters')
#            
#===============================================================================
      
        