'''
Created on 28/04/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals

class KitchenWindow(InteractionObject):
    def __init__(self,ia):
        super(KitchenWindow,self).__init__(ia)
        
    def entered(self):
        gm = globals.game
        pl = globals.player
        if not self.enteredBefore:
            gm.displayText("It's a nice day outside",4.0)
        else:
            gm.displayText("Looking out the window makes me depressed", 4.0)
            
        InteractionObject.entered(self)

class Bin(InteractionObject):
    def __init__(self,ia):
        super(Bin,self).__init__(ia)
        
    def used(self,item):
        gm = globals.game
        pl = globals.player
        InteractionObject.entered(self)  
        gm.query(self,["Grab them"],"There's an old pair of gloves in the bin")
        
    def notify(self,str):
        if str=="Grab them":
            globals.player.addItem("gloves")
      
class KitchenFridge(InteractionObject):
    def __init__(self,ia):
        super(KitchenFridge,self).__init__(ia)
        self.contents = ["a pineapple","a stripey fruit","a polkadot fruit","some strange meat"]
        
    def used(self,item):
        InteractionObject.used(self,item)
        gm = globals.game
        pl = globals.player
        
        if len(self.contents)>0:
            gm.query(self,["take "+c for c in self.contents],"The fridge smells funny. It contains various strange objects.")
        else:
            gm.displayText("I'm not opening that fridge again",2.5)
            gm.scheduleOnce(lambda dt: gm.displayText("...ever",3.0), 2.5)
        
    def notify(self,str):
        if str==None: return
        
        gm = globals.game
        pl = globals.player
        if str[:4]=="take":
            takewhat = str[5:]
            self.contents.remove(takewhat)
            pl.addItem(takewhat)
            
class Kitchen(Room):
    '''
    The kitchen area.
    '''

    def __init__(self):
        #super(Kitchen,self).__init__("The Kitchen","kitchen.dat")
        #self.loadAndSortObjects({'fridge':1,'bench':0},{'fridge':'fridge.png','bench':'bench.png'})
        
        super(Kitchen,self).__init__("A kitchen","kitchen.dat")
        self.loadAndSortObjects({'fridge':StaticThing('fridge_closed.png'),'bin':StaticThing('bin.png')})
        self.setInteractionZones({'window':KitchenWindow,'fridge':KitchenFridge,'bin':Bin})        
        