
'''
Created on 01/05/2009

@author: ben
'''



'''
Created on 01/05/2009

@author: ben
'''

from room import (Room,InteractionObject)
from things import (Thing,StaticThing)
import globals
import random
import pyglet
from pyglet import gl
from characters import Player

class Ball(InteractionObject):
    def __init__(self,ia):
        super(Ball,self).__init__(ia)
        self.active = True
        self.ball = None
        
    def used(self,item):
        InteractionObject.used(self,item)
        if self.active:       
            gm = globals.game
            pl = globals.player
            
            gm.displayText("I've got my ball, now I should get out of here!", 4.0)
            pl.addItem("ball")
            self.ball.show = False
            gm.notify("got ball")            

class TVThing(Thing):        
    def __init__(self):
        super(TVThing,self).__init__()
        
        self.imgOns = pyglet.image.ImageGrid(pyglet.resource.image("tv_on.png"),1,4)
        self.imgOff = pyglet.resource.image("tv_off.png")
        self.imgs = [img for img in self.imgOns] + [self.imgOff]
        
        self.on = True
                
    def postinit(self):
        if self.pivot:
            for img in self.imgs:
                img.anchor_x,img.anchor_y = self.pivot.x,self.pivot.y
            
    def draw(self):        
        if self.on:
            img = random.choice(self.imgOns)
        else:
            img = self.imgOff
        img.blit(self.position.x,self.position.y)

class TVArea(InteractionObject):
    def __init__(self,ia):
        super(TVArea,self).__init__(ia)
        self.powered = True       
        self.tv = None
        
    def used(self,item):
        super(TVArea,self).used(item)
        self.tv.on = not self.tv.on        

class DrinkArea(InteractionObject):
    def __init__(self,ia):
        super(DrinkArea,self).__init__(ia)
        self.pills = ["blue pill","red pill"]
        self.contents = []
        self.msgcount = 0
    
    def entered(self):
        InteractionObject.entered(self)        
        gm = globals.game
        pl = globals.player
        
        if self.msgcount>5:
            gm.displayText("Maybe I could ... drug him?", 4.0)
        else:
            gm.displayText("Looks like lime and soda, smells like petrol", 4.0)
            self.msgcount += 1
                
    def used(self,item):
        super(DrinkArea,self).used(item)
        
        gm = globals.game
        pl = globals.player
        
        options = []
        for p in self.pills:
            if p not in self.contents and pl.hasItem(p):
                options.append(p)
        gm.query(self,["slip in "+p for p in options]+["drink it"])
                
    def notify(self,str):
        gm = globals.game
        pl = globals.player
        
        if str is None: return
        elif str[:8]=="slip in ":
            
            pill = str[8:]
            self.contents.append(pill)
            gm.displayText("Slipped " + pill + " in his drink ")
            pl.removeItem(pill)
        elif str=="drink it":
            if len(self.contents)==0:
                gm.displayText("wow, flavoursome!")
            elif "blue pill" in self.contents and not "red pill" in self.contents:
                gm.ending("fell asleep")
            elif "red pill" in self.contents and not "blue pill" in self.contents:
                gm.displayText("The world slows down around you ... ", 5)
                Player.walkingSpeed *= 2
            else:
                # must be both
                gm.notify("kooky shit")          

class SleepingBody(InteractionObject):
    def __init__(self,ia):
        super(SleepingBody,self).__init__(ia)
        self.enabled = False
        self.kicked = False

    def setPosition(self,pos):
        self.ia.x = pos.x
        self.ia.y = pos.y
        
    def used(self,item):
        if self.enabled:
            super(SleepingBody,self).used(item)
            if not self.kicked:
                globals.game.displayText("You kick him ... he doesn't wake up", 4.0)
                self.kicked = True
            else:
                globals.game.displayText("You see some keys in his pocket and pick them up", 4.0)
                globals.player.addItem("front door key")
                globals.game.notify("unlock desk")

class FrontDoor(InteractionObject):
    def __init__(self,ia):
        super(FrontDoor,self).__init__(ia)
  
    def used(self,item):
        pl = globals.player
        gm = globals.game
        if not pl.hasItem("front door key"):
            gm.displayText("It's locked ... I need a key.")
        elif pl.hasItem("front door key") and pl.hasItem("ball"):
            gm.ending("out front door")
        else:
            gm.displayText("I can't leave without the ball!")
               
class LoungeRoom(Room):

    def __init__(self):
        super(LoungeRoom,self).__init__("A loungeroom","loungeroom.dat")
        self.loadAndSortObjects(
                                {'ball':StaticThing("soccerball.png"),
                                 'tv':TVThing(),
                                 'chair':StaticThing("chair.png"),
                                 'table':StaticThing("table.png"),
                                 'drink':StaticThing("drink.png"),
                                 })
        
        self.setInteractionZones({'tv':TVArea,
                                  'ball':Ball,
                                  'drink':DrinkArea,
                                  'frontdoor':FrontDoor,
                                  'sleepingbody':SleepingBody})
        
        self.getInteractionObject('ball').ball = self.getObject('ball')   
        self.getInteractionObject('tv').tv = self.getObject('tv') 
      